var ZeedhiEvents = angular.module("ZeedhiEvents");

ZeedhiEvents.directive('zhEvents', function(templateManager, eventEngine) {
	return {
		restrict: 'A',
		priority: 400,
		link: function link($scope, element, attrs) {
			var owner = attrs.zhEvents ? $scope.$eval(attrs.zhEvents) : $scope.field;
			var widget = owner.widget;
			var events = owner.events;

			var businessEventsAttrs = attrs.businessEvents ? attrs.businessEvents.split('|') : [];
			var businessEvents = [];

			if (businessEventsAttrs.length) {
				events = events.filter(function(event) {
					var isBusinessEvent = businessEventsAttrs.indexOf(event.name) !== -1;
					if (isBusinessEvent) {
						businessEvents.push(event);
					}
					return !isBusinessEvent;
				});
			}

			element.owner = owner;
			element.field = owner; // Compatibility
			owner.element = element;

			element.getParent = function() {
				return owner;
			};
			// preventDefault cannot happen if field is inside a grid or a list
			owner.shouldNotPreventDefaultOnClick = element.parents('.zh-grid-container').length !== 0 || element.parents('.zh-list-container').length !== 0 || element.parents('.zh-observation').length !== 0;

			if (events && events.length) {
				bindEvents(element, events);
			}

			if (businessEvents && businessEvents.length) {
				bindEvents(element.owner, businessEvents);
			}

			function bindEvents(owner, events) {
				eventEngine.bindEvents(owner, events,
					function() {
						if (widget.dataSource) {
							return widget.dataSource.data;
						}
					},
					function() {
						return widget.currentRow;
					},
					function() {
						return widget.selectedRow;
					}
				);
			}
		}
	};
});